## iotop-c 1.9

=== Makefile ===
# use this to disable flto optimizations:
#   make NO_FLTO=1
# and this to enable verbose mode:
#   make V=1

#
# SPDX-License-Identifer: GPL-2.0-or-later
#
# Copyright (C) 2014  Vyacheslav Trushkin
# Copyright (C) 2020  Boian Bonev
#
# This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#

TARGET=iotop

SRCS:=$(wildcard src/*.c)
OBJS:=$(patsubst %c,%o,$(patsubst src/%,bld/%,$(SRCS)))
DEPS:=$(OBJS:.o=.d)

ifndef NO_FLTO
CFLAGS?=-O3 -fno-stack-protector -mno-stackrealign -flto
LDFLAGS+=-O3 -fno-stack-protector -mno-stackrealign -flto
else
CFLAGS?=-O3 -fno-stack-protector -mno-stackrealign
endif

MYCFLAGS:=$(CPPFLAGS) $(CFLAGS) -std=gnu90 -Wall -Wextra
MYLIBS=$(LIBS) -lncursesw
MYLDFLAGS=$(LDFLAGS)
STRIP?=strip

PREFIX?=$(DESTDIR)/usr

ifeq ("$(V)","1")
Q:=
E:=@true
else
Q:=@
E:=@echo
endif

all: $(TARGET)

$(TARGET): $(OBJS)
	$(E) LD $@
	$(Q)$(CC) -o $@ $(MYLDFLAGS) $^ $(MYLIBS)

bld/%.o: src/%.c bld/.mkdir
	$(E) DE $@
	$(Q)$(CC) $(MYCFLAGS) -MM -MT $@ -MF $(patsubst %.o,%.d,$@) $<
	$(E) CC $@
	$(Q)$(CC) $(MYCFLAGS) -c -o $@ $<

clean:
	$(E) CLEAN
	$(Q)rm -rf ./bld $(TARGET)

install: $(TARGET)
	$(E) STRIP $(TARGET)
	$(Q)$(STRIP) $(TARGET)
	$(E) INSTALL $(TARGET)
	$(Q)install -TD -m 0755 $(TARGET) $(PREFIX)/sbin/$(TARGET)

uninstall:
	$(E) UNINSTALL $(TARGET)
	$(Q)rm $(PREFIX)/sbin/$(TARGET)

bld/.mkdir:
	$(Q)mkdir -p bld
	$(Q)touch bld/.mkdir

-include $(DEPS)

.PHONY: clean install uninstall

=== debian/changelog ===
iotop-c (1.9-1) unstable; urgency=medium

  * Add Vcs-* tags
  * Update to new upstream release of 1.9
  * Bump debhelper-compat to 13

 -- Boian Bonev <bbonev@ipacct.com>  Sat, 22 Aug 2020 02:10:44 +0000

iotop-c (1.8-1) unstable; urgency=medium

  * Initial release (Closes: #963612)

 -- Boian Bonev <bbonev@ipacct.com>  Thu, 02 Jul 2020 09:20:46 +0000

=== debian/control ===
Source: iotop-c
Section: admin
Priority: optional
Maintainer: Boian Bonev <bbonev@ipacct.com>
Build-Depends:
 debhelper-compat (= 13),
 libncurses-dev,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://github.com/Tomas-M/iotop
Vcs-Browser: https://github.com/Tomas-M/iotop
Vcs-Git: https://github.com/Tomas-M/iotop.git

Package: iotop-c
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Replaces:
 iotop (<= 0.6-24-g733f3f8-1),
Breaks:
 iotop (<= 0.6-24-g733f3f8-1),
Description: simple top-like I/O monitor (implemented in C)
 iotop-c does for I/O usage what top(1) does for CPU usage. It watches I/O
 usage information output by the Linux kernel and displays a table of
 current I/O usage by processes on the system. It is handy for answering
 the question "Why is the disk churning so much?".
 .
 iotop-c requires a Linux kernel built with the CONFIG_TASKSTATS,
 CONFIG_TASK_DELAY_ACCT, CONFIG_TASK_IO_ACCOUNTING and
 CONFIG_VM_EVENT_COUNTERS config options on.
 .
 iotop-c is an alternative reimplementation of iotop in C, optimized for
 performance. Normally a monitoring tool intended to be used on a system
 under heavy stress should use the least additional resources as
 possible.

=== debian/rules ===
#!/usr/bin/make -f

# use the default Debian build options; do not strip as dh_* scripts strip the binary
export NO_FLTO=1
export STRIP=/bin/true
ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
export V=1
else
export V=0
endif
export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

%:
	dh $@

override_dh_install:
	dh_install
	mv debian/iotop-c/usr/sbin/iotop debian/iotop-c/usr/sbin/iotop-c
	mkdir -p debian/iotop-c/usr/share/man/man8
	cp debian/iotop.8 debian/iotop-c/usr/share/man/man8/iotop-c.8

=== debian/watch ===
version=4

opts=\
	"filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%iotop-c_$1.orig.tar.gz%,pgpsigurlmangle=s/archive\/v([0-9.]+)\.tar\.gz/releases\/download\/v$1\/iotop-$1\.tar\.gz\.asc/" \
	https://github.com/Tomas-M/iotop/tags \
	(?:.*?/)?v?(\d[\d.]*)\.tar\.gz \
	debian uupdate

## iotop-c 1.17

=== Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
 # SPDX-License-Identifer: GPL-2.0-or-later
 #
 # Copyright (C) 2014  Vyacheslav Trushkin
-# Copyright (C) 2020  Boian Bonev
+# Copyright (C) 2020,2021  Boian Bonev
 #
 # This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
 #
@@ -23,15 +23,28 @@
 DEPS:=$(OBJS:.o=.d)
 
 ifndef NO_FLTO
-CFLAGS?=-O3 -fno-stack-protector -mno-stackrealign -flto
-LDFLAGS+=-O3 -fno-stack-protector -mno-stackrealign -flto
+CFLAGS?=-O3 -fno-stack-protector -mno-stackrealign
+CFLAGS+=-flto
+LDFLAGS+=$(CFLAGS)
 else
 CFLAGS?=-O3 -fno-stack-protector -mno-stackrealign
 endif
 
-MYCFLAGS:=$(CPPFLAGS) $(CFLAGS) -std=gnu90 -Wall -Wextra
-MYLIBS=$(LIBS) -lncursesw
-MYLDFLAGS=$(LDFLAGS)
+PKG_CONFIG?=pkg-config
+NCCC?=$(shell $(PKG_CONFIG) --cflags ncursesw)
+NCLD?=$(shell $(PKG_CONFIG) --libs ncursesw)
+ifeq ("$(NCLD)","")
+NCCC:=$(shell $(PKG_CONFIG) --cflags ncurses)
+NCLD:=$(shell $(PKG_CONFIG) --libs ncurses)
+endif
+ifeq ("$(NCLD)","")
+NCCC:=
+NCLD:=-lncursesw
+endif
+
+MYCFLAGS:=$(CPPFLAGS) $(CFLAGS) $(NCCC) -std=gnu90 -Wall -Wextra -fPIE
+MYLIBS=$(LIBS) $(NCLD)
+MYLDFLAGS=$(LDFLAGS) -fPIE -pie
 STRIP?=strip
 
 PREFIX?=$(DESTDIR)/usr
@@ -65,6 +78,7 @@
 	$(Q)$(STRIP) $(TARGET)
 	$(E) INSTALL $(TARGET)
 	$(Q)install -TD -m 0755 $(TARGET) $(PREFIX)/sbin/$(TARGET)
+	$(Q)install -TD -m 0644 iotop.8 $(PREFIX)/share/man/man8/iotop.8
 
 uninstall:
 	$(E) UNINSTALL $(TARGET)
@@ -74,6 +88,22 @@
 	$(Q)mkdir -p bld
 	$(Q)touch bld/.mkdir
 
+VER:=$(shell grep VERSION src/iotop.h|tr -d '\"'|awk '{print $$3}')
+mkotar:
+	$(MAKE) clean
+	-dh_clean
+	tar \
+		--xform 's,^[.],iotop-$(VER),' \
+		--exclude ./.git \
+		--exclude ./.gitignore \
+		--exclude ./debian \
+		--exclude ./fedora \
+		-Jcvf ../iotop-c_$(VER).orig.tar.xz .
+	-rm -f ../iotop-c_$(VER).orig.tar.xz.asc
+	gpg -a --detach-sign ../iotop-c_$(VER).orig.tar.xz
+	cp -fa ../iotop-c_$(VER).orig.tar.xz ../iotop-$(VER).tar.xz
+	cp -fa ../iotop-c_$(VER).orig.tar.xz.asc ../iotop-$(VER).tar.xz.asc
+
 -include $(DEPS)
 
 .PHONY: clean install uninstall

=== debian/changelog ===
iotop-c (1.17-1+deb11u1) bullseye; urgency=medium

  * Backport bugfix from 1.18
    - fix OOB access caused by UTF8 process names

 -- Boian Bonev <bbonev@ipacct.com>  Mon, 06 Sep 2021 01:54:40 +0000

iotop-c (1.17-1) unstable; urgency=medium

  * Update to new upstream release of 1.17

 -- Boian Bonev <bbonev@ipacct.com>  Sat, 06 Feb 2021 01:02:03 +0000

iotop-c (1.16-1) unstable; urgency=medium

  * Update standards to 4.5.1
  * Update to new upstream release of 1.16

 -- Boian Bonev <bbonev@ipacct.com>  Mon, 25 Jan 2021 05:01:28 +0000

iotop-c (1.15-1) unstable; urgency=medium

  * Update to new upstream release of 1.15
    - fix read return value converted to unsugned (and possible OOB in the rare
      case that happens
    - fix keypress ignored during screen refresh
    - fix Ctrl-L to really redraw screen

 -- Boian Bonev <bbonev@ipacct.com>  Wed, 30 Sep 2020 14:49:57 +0000

iotop-c (1.14-1) unstable; urgency=medium

  * Update to new upstream release of 1.12
    - fix SIGSEGV in humanize_val on large values
    - convert the pseudo-graph to a normal column
    - remove option -s (replaced by -8 with inverse logic)
    - add sort by the pseudo-graph column
    - make sort by the pseudo-graph the default
    - implement hiding columns by options and shortcuts 1...9
    - revise column widths
    - rewrite curses event loop to make data collection separate from refresh
    - fix sorting (proper double value comparison)
  * Update to new upstream release of 1.14
    - fix off-by-one errors in size calculation to avoid truncated strings
    - unify snprintf usage according to glibc semantics
    - keep both variants of cmdline in memory for immediate display change
      (hotkey c)
    - rewrite get_vm_counters with simpler io
    - nuke the remnants of -s/--iohistory options
    - be more strict to unrecognized arguments
  * Remove debian folder from release tarballs (lintian: no-debian-changes)
  * Change release tarballs url in debian/watch

 -- Boian Bonev <bbonev@ipacct.com>  Thu, 24 Sep 2020 00:28:13 +0000

iotop-c (1.11-1) unstable; urgency=medium

  * Update to new upstream release of 1.10
    - add pseudo graphs for total IO activity
    - add detection of UTF support, fallback to ASCII
    - add shortcut to toggle UTF/ASCII
    - improve build checks for printf-like ncurses API
  * Convert alternatives to debhelper instead of shell scripts
  * Add debian/upstream/metadata
  * Update to new upstream release of 1.11
    - better detection of locale/terminal
    - add graph and UTF/ASCII toggles to help
    - increase history to 60 datapoints
    - make graphs scale as screen size changes
    - always keep track of history data (graph display toggle no
      longer affects the data collected)
    - use the history data as 'only' filter in interactive mode
  * Add build-dep on pkg-config
  * wrap-and-sort in the proper way

 -- Boian Bonev <bbonev@ipacct.com>  Wed, 02 Sep 2020 20:41:00 +0300

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,8 @@
 Build-Depends:
  debhelper-compat (= 13),
  libncurses-dev,
-Standards-Version: 4.5.0
+ pkg-config,
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://github.com/Tomas-M/iotop
 Vcs-Browser: https://github.com/Tomas-M/iotop
@@ -30,7 +31,7 @@
  CONFIG_TASK_DELAY_ACCT, CONFIG_TASK_IO_ACCOUNTING and
  CONFIG_VM_EVENT_COUNTERS config options on.
  .
- iotop-c is an alternative reimplementation of iotop in C, optimized for
+ iotop-c is an alternative re-implementation of iotop in C, optimized for
  performance. Normally a monitoring tool intended to be used on a system
  under heavy stress should use the least additional resources as
  possible.

=== debian/watch ===
version=4

opts=\
	"filenamemangle=s%(?:.*?)?iotop-?(\d[\d.]*)\.tar\.xz%iotop-c_$1.orig.tar.xz%,pgpsigurlmangle=s/releases\/download\/v([0-9.]+)\/iotop-([0-9.]+)\.tar\.xz/releases\/download\/v$1\/iotop-$1\.tar\.xz\.asc/" \
	https://github.com/Tomas-M/iotop/releases \
	(?:.*?/)?iotop-?(\d[\d.]*)\.tar\.xz \
	debian uupdate

## iotop-c 1.20

=== debian/changelog ===
iotop-c (1.20-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boian Bonev <bbonev@ipacct.com>  Sun, 10 Oct 2021 01:42:46 +0000

iotop-c (1.20-1) unstable; urgency=medium

  * Update to new upstream release of 1.20
    - Add support for kernel 5.14+ task_delayacct sysctl

 -- Boian Bonev <bbonev@ipacct.com>  Mon, 04 Oct 2021 23:56:24 +0000

iotop-c (1.19-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boian Bonev <bbonev@ipacct.com>  Tue, 28 Sep 2021 22:51:46 +0000

iotop-c (1.19-1) unstable; urgency=medium

  * Update to new upstream release of 1.19
    - Do not crash if TERM is not set

 -- Boian Bonev <bbonev@ipacct.com>  Tue, 21 Sep 2021 08:30:10 +0000

iotop-c (1.18-1~bpo11+2) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.
  * Backport fix from 1.19
    - Do not crash if TERM is not set

 -- Boian Bonev <bbonev@ipacct.com>  Wed, 22 Sep 2021 21:08:16 +0000

iotop-c (1.18-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boian Bonev <bbonev@ipacct.com>  Mon, 20 Sep 2021 22:47:41 +0000

iotop-c (1.18-1) unstable; urgency=medium

  * Update to new upstream release of 1.18
  * Update standards to 4.6.0

 -- Boian Bonev <bbonev@ipacct.com>  Tue, 24 Aug 2021 02:45:57 +0000

## iotop-c 1.21

=== Makefile ===
--- 
+++ 
@@ -25,9 +25,19 @@
 ifndef NO_FLTO
 CFLAGS?=-O3 -fno-stack-protector -mno-stackrealign
 CFLAGS+=-flto
-LDFLAGS+=$(CFLAGS)
 else
 CFLAGS?=-O3 -fno-stack-protector -mno-stackrealign
+endif
+
+ifdef GCCFANALIZER
+CFLAGS+=-fanalyzer
+endif
+
+INSTALL?=install
+
+HAVESREA:=$(shell if $(CC) -mno-stackrealign -c /dev/null -o /dev/null >/dev/null 2>/dev/null;then echo yes;else echo no;fi)
+ifeq ("$(HAVESREA)","no")
+CFLAGS:=$(filter-out -mno-stackrealign,$(CFLAGS))
 endif
 
 PKG_CONFIG?=pkg-config
@@ -42,9 +52,15 @@
 NCLD:=-lncursesw
 endif
 
-MYCFLAGS:=$(CPPFLAGS) $(CFLAGS) $(NCCC) -std=gnu90 -Wall -Wextra -fPIE
-MYLIBS=$(LIBS) $(NCLD)
-MYLDFLAGS=$(LDFLAGS) -fPIE -pie
+# for glibc < 2.17, -lrt is required for clock_gettime
+NEEDLRT:=$(shell if $(CC) -E glibcvertest.h -o -|grep IOTOP_NEED_LRT|grep -q yes;then echo need; fi)
+
+MYCFLAGS:=$(CPPFLAGS) $(CFLAGS) $(NCCC) -Wall -Wextra -Wformat -Werror=format-security -Wdate-time -D_FORTIFY_SOURCE=2 --std=gnu90 -fPIE
+MYLIBS:=$(NCLD) $(LIBS)
+MYLDFLAGS:=$(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -fPIE -pie
+ifeq ("$(NEEDLRT)","need")
+MYLDFLAGS+=-lrt
+endif
 STRIP?=strip
 
 PREFIX?=$(DESTDIR)/usr
@@ -77,12 +93,13 @@
 	$(E) STRIP $(TARGET)
 	$(Q)$(STRIP) $(TARGET)
 	$(E) INSTALL $(TARGET)
-	$(Q)install -TD -m 0755 $(TARGET) $(PREFIX)/sbin/$(TARGET)
-	$(Q)install -TD -m 0644 iotop.8 $(PREFIX)/share/man/man8/iotop.8
+	$(Q)$(INSTALL) -D -m 0755 $(TARGET) $(PREFIX)/sbin/$(TARGET)
+	$(Q)$(INSTALL) -D -m 0644 iotop.8 $(PREFIX)/share/man/man8/iotop.8
 
 uninstall:
 	$(E) UNINSTALL $(TARGET)
-	$(Q)rm $(PREFIX)/sbin/$(TARGET)
+	$(Q)rm -f $(PREFIX)/sbin/$(TARGET)
+	$(Q)rm -f $(PREFIX)/share/man/man8/iotop.8
 
 bld/.mkdir:
 	$(Q)mkdir -p bld
@@ -97,7 +114,6 @@
 		--exclude ./.git \
 		--exclude ./.gitignore \
 		--exclude ./debian \
-		--exclude ./fedora \
 		-Jcvf ../iotop-c_$(VER).orig.tar.xz .
 	-rm -f ../iotop-c_$(VER).orig.tar.xz.asc
 	gpg -a --detach-sign ../iotop-c_$(VER).orig.tar.xz

=== debian/changelog ===
iotop-c (1.21-1) unstable; urgency=medium

  * Update to new upstream release of 1.21
    - Better support for disabled task_delayacct sysctl
    - Add history and graph for all data
    - Restore simple inline help
  * Remove filenamemangle from d/watch

 -- Boian Bonev <bbonev@ipacct.com>  Wed, 26 Jan 2022 15:20:46 +0000

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  debhelper-compat (= 13),
  libncurses-dev,
  pkg-config,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://github.com/Tomas-M/iotop
 Vcs-Browser: https://github.com/Tomas-M/iotop

=== debian/watch ===
version=4

opts=\
	"pgpsigurlmangle=s/releases\/download\/v([0-9.]+)\/iotop-([0-9.]+)\.tar\.xz/releases\/download\/v$1\/iotop-$1\.tar\.xz\.asc/" \
	https://github.com/Tomas-M/iotop/releases \
	(?:.*?/)?iotop-?(\d[\d.]*)\.tar\.xz \
	debian uupdate

## iotop-c 1.22

=== Makefile ===
--- 
+++ 
@@ -4,10 +4,10 @@
 #   make V=1
 
 #
-# SPDX-License-Identifer: GPL-2.0-or-later
+# SPDX-License-Identifier: GPL-2.0-or-later
 #
 # Copyright (C) 2014  Vyacheslav Trushkin
-# Copyright (C) 2020,2021  Boian Bonev
+# Copyright (C) 2020,2022  Boian Bonev
 #
 # This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
 #

=== debian/changelog ===
iotop-c (1.22-1) unstable; urgency=medium

  * Update to new upstream release of 1.22
  * Update standards to 4.6.1, no changes

 -- Boian Bonev <bbonev@ipacct.com>  Sat, 09 Jul 2022 23:54:01 +0000

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  debhelper-compat (= 13),
  libncurses-dev,
  pkg-config,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://github.com/Tomas-M/iotop
 Vcs-Browser: https://github.com/Tomas-M/iotop

## iotop-c 1.23

=== Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
 # SPDX-License-Identifier: GPL-2.0-or-later
 #
 # Copyright (C) 2014  Vyacheslav Trushkin
-# Copyright (C) 2020,2022  Boian Bonev
+# Copyright (C) 2020-2023  Boian Bonev
 #
 # This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
 #
@@ -24,7 +24,7 @@
 
 ifndef NO_FLTO
 CFLAGS?=-O3 -fno-stack-protector -mno-stackrealign
-CFLAGS+=-flto
+CFLAGS+=-flto=auto
 else
 CFLAGS?=-O3 -fno-stack-protector -mno-stackrealign
 endif
@@ -120,6 +120,10 @@
 	cp -fa ../iotop-c_$(VER).orig.tar.xz ../iotop-$(VER).tar.xz
 	cp -fa ../iotop-c_$(VER).orig.tar.xz.asc ../iotop-$(VER).tar.xz.asc
 
+re:
+	$(Q)$(MAKE) --no-print-directory clean
+	$(Q)$(MAKE) --no-print-directory -j
+
 -include $(DEPS)
 
-.PHONY: clean install uninstall
+.PHONY: all clean install uninstall mkotar re

=== debian/changelog ===
iotop-c (1.23-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boian Bonev <bbonev@ipacct.com>  Sun, 29 Jan 2023 20:51:49 +0000

iotop-c (1.23-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Re-export upstream signing key without extra signatures.
  * Fix day-of-week for changelog entry 1.22-1.
  * Update standards version to 4.6.1, no changes needed.

  [ Boian Bonev ]
  * Update standards version to 4.6.2, no changes needed.
  * Update to new upstream release of 1.23
  * Fix d/watch

 -- Boian Bonev <bbonev@ipacct.com>  Tue, 24 Jan 2023 00:00:31 +0000

iotop-c (1.22-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boian Bonev <bbonev@ipacct.com>  Sat, 16 Jul 2022 02:18:46 +0300

iotop-c (1.21-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boian Bonev <bbonev@ipacct.com>  Thu, 27 Jan 2022 21:59:45 +0200

## iotop-c 1.26

=== Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
 # SPDX-License-Identifier: GPL-2.0-or-later
 #
 # Copyright (C) 2014  Vyacheslav Trushkin
-# Copyright (C) 2020-2023  Boian Bonev
+# Copyright (C) 2020-2024  Boian Bonev
 #
 # This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
 #
@@ -33,12 +33,9 @@
 CFLAGS+=-fanalyzer
 endif
 
+PREFIX?=$(DESTDIR)/usr
 INSTALL?=install
-
-HAVESREA:=$(shell if $(CC) -mno-stackrealign -c /dev/null -o /dev/null >/dev/null 2>/dev/null;then echo yes;else echo no;fi)
-ifeq ("$(HAVESREA)","no")
-CFLAGS:=$(filter-out -mno-stackrealign,$(CFLAGS))
-endif
+STRIP?=strip
 
 PKG_CONFIG?=pkg-config
 NCCC?=$(shell $(PKG_CONFIG) --cflags ncursesw)
@@ -54,16 +51,28 @@
 
 # for glibc < 2.17, -lrt is required for clock_gettime
 NEEDLRT:=$(shell if $(CC) -E glibcvertest.h -o -|grep IOTOP_NEED_LRT|grep -q yes;then echo need; fi)
+# some architectures do not have -mno-stackrealign
+HAVESREA:=$(shell if $(CC) -mno-stackrealign -xc -c /dev/null -o /dev/null >/dev/null 2>/dev/null;then echo yes;else echo no;fi)
+# old comiplers do not have -Wdate-time
+HAVEWDTI:=$(shell if $(CC) -Wdate-time -xc -c /dev/null -o /dev/null >/dev/null 2>/dev/null;then echo yes;else echo no;fi)
 
-MYCFLAGS:=$(CPPFLAGS) $(CFLAGS) $(NCCC) -Wall -Wextra -Wformat -Werror=format-security -Wdate-time -D_FORTIFY_SOURCE=2 --std=gnu90 -fPIE
+MYCFLAGS:=$(CPPFLAGS) $(CFLAGS) $(NCCC) -Wall -Wextra -Wformat -Werror=format-security -Wdate-time -D_FORTIFY_SOURCE=2 --std=gnu89 -fPIE
 MYLIBS:=$(NCLD) $(LIBS)
 MYLDFLAGS:=$(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -fPIE -pie
+
+ifeq ("$(HAVESREA)","no")
+MYCFLAGS:=$(filter-out -mno-stackrealign,$(MYCFLAGS))
+MYLDFLAGS:=$(filter-out -mno-stackrealign,$(MYLDFLAGS))
+endif
+
+ifeq ("$(HAVEWDTI)","no")
+MYCFLAGS:=$(filter-out -Wdate-time,$(MYCFLAGS))
+MYLDFLAGS:=$(filter-out -Wdate-time,$(MYLDFLAGS))
+endif
+
 ifeq ("$(NEEDLRT)","need")
 MYLDFLAGS+=-lrt
 endif
-STRIP?=strip
-
-PREFIX?=$(DESTDIR)/usr
 
 ifeq ("$(V)","1")
 Q:=
@@ -124,6 +133,19 @@
 	$(Q)$(MAKE) --no-print-directory clean
 	$(Q)$(MAKE) --no-print-directory -j
 
+pv:
+	@echo CFLAGS: $(CFLAGS)
+	@echo LDFLAGS: $(LDFLAGS)
+	@echo LIBS: $(LIBS)
+	@echo NCCC: $(NCCC)
+	@echo NCLD: $(NCLD)
+	@echo NEEDLRT: $(NEEDLRT)
+	@echo HAVESREA: $(HAVESREA)
+	@echo HAVEWDTI: $(HAVEWDTI)
+	@echo MYCFLAGS: $(MYCFLAGS)
+	@echo MYLDFLAGS: $(MYLDFLAGS)
+	@echo MYLIBS: $(MYLIBS)
+
 -include $(DEPS)
 
-.PHONY: all clean install uninstall mkotar re
+.PHONY: all clean install uninstall mkotar re pv

=== debian/changelog ===
iotop-c (1.26-1) unstable; urgency=medium

  * Update to new upstream release of 1.26
    - Clock in upper right corner

 -- Boian Bonev <bbonev@ipacct.com>  Sat, 03 Feb 2024 13:45:39 +0000

iotop-c (1.25-1) unstable; urgency=medium

  * Update to new upstream release of 1.25
    - Fix ESC makes iotop busy loop
    - Fix the logic in 'only' option

 -- Boian Bonev <bbonev@ipacct.com>  Sat, 14 Oct 2023 08:49:48 +0000

iotop-c (1.24-1) unstable; urgency=medium

  * Update to new upstream release of 1.24
    - Fix a bug with graphs in ASCII mode
    - Show the status of the configuration in the help window

 -- Boian Bonev <bbonev@ipacct.com>  Sat, 30 Sep 2023 23:04:47 +0000

## iotop-c 1.27

=== Makefile ===
--- 
+++ 
@@ -2,12 +2,14 @@
 #   make NO_FLTO=1
 # and this to enable verbose mode:
 #   make V=1
+# an example how to build with CFI (https://en.wikipedia.org/wiki/Control-flow_integrity)
+#   CC=clang-17 CFLAGS="-fsanitize=cfi -fno-sanitize-trap -fvisibility=hidden" make
 
 #
 # SPDX-License-Identifier: GPL-2.0-or-later
 #
 # Copyright (C) 2014  Vyacheslav Trushkin
-# Copyright (C) 2020-2024  Boian Bonev
+# Copyright (C) 2020-2025  Boian Bonev
 #
 # This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
 #
@@ -55,6 +57,16 @@
 HAVESREA:=$(shell if $(CC) -mno-stackrealign -xc -c /dev/null -o /dev/null >/dev/null 2>/dev/null;then echo yes;else echo no;fi)
 # old comiplers do not have -Wdate-time
 HAVEWDTI:=$(shell if $(CC) -Wdate-time -xc -c /dev/null -o /dev/null >/dev/null 2>/dev/null;then echo yes;else echo no;fi)
+# old compilers can not generate dependecies
+HAVEDEPS:=$(shell if $(CC) -MM -MT /dev/null -MF /dev/null /dev/null >/dev/null 2>/dev/null;then echo yes;else echo no;fi)
+# old compilers do not understand C standard
+HAVECSTD:=$(shell if $(CC) --std=gnu89 -xc -c /dev/null -o /dev/null >/dev/null 2>/dev/null;then echo yes;else echo no;fi)
+# old compilers do not understand -flto=auto
+HAVEFLTA:=$(shell if $(CC) -flto=auto -xc -c /dev/null -o /dev/null >/dev/null 2>/dev/null;then echo yes;else echo no;fi)
+# old compilers do not understand -flto at all
+HAVEFLTO:=$(shell if $(CC) -flto -xc -c /dev/null -o /dev/null >/dev/null 2>/dev/null;then echo yes;else echo no;fi)
+# old compilers do not understand -pie; clang yields error when stderr is redirected :(
+HAVELPIE:=$(shell if $(CC) -Wno-unused-command-line-argument -pie -xc -c /dev/null -o /dev/null >/dev/null 2>/dev/null;then echo yes;else echo no;fi)
 
 MYCFLAGS:=$(CPPFLAGS) $(CFLAGS) $(NCCC) -Wall -Wextra -Wformat -Werror=format-security -Wdate-time -D_FORTIFY_SOURCE=2 --std=gnu89 -fPIE
 MYLIBS:=$(NCLD) $(LIBS)
@@ -70,6 +82,31 @@
 MYLDFLAGS:=$(filter-out -Wdate-time,$(MYLDFLAGS))
 endif
 
+ifeq ("$(HAVECSTD)","no")
+MYCFLAGS:=$(filter-out --std=gnu89,$(MYCFLAGS))
+MYLDFLAGS:=$(filter-out --std=gnu89,$(MYLDFLAGS))
+MYCFLAGS:=$(filter-out -D_FORTIFY_SOURCE=2,$(MYCFLAGS))
+MYLDFLAGS:=$(filter-out -D_FORTIFY_SOURCE=2,$(MYLDFLAGS))
+endif
+
+ifeq ("$(HAVEFLTA)","no")
+ifndef NO_FLTO
+ifeq ("$(HAVEFLTA)","no")
+MYCFLAGS:=$(filter-out -flto=auto,$(MYCFLAGS))
+MYLDFLAGS:=$(filter-out -flto=auto,$(MYLDFLAGS))
+else
+MYCFLAGS:=$(filter-out -flto=auto,$(MYCFLAGS))
+MYLDFLAGS:=$(filter-out -flto=auto,$(MYLDFLAGS))
+MYCFLAGS+=-flto
+MYLDFLAGS+=-flto
+endif
+endif
+endif
+
+ifeq ("$(HAVELPIE)","no")
+MYLDFLAGS:=$(filter-out -pie,$(MYLDFLAGS))
+endif
+
 ifeq ("$(NEEDLRT)","need")
 MYLDFLAGS+=-lrt
 endif
@@ -82,6 +119,12 @@
 E:=@echo
 endif
 
+ifeq ("$(HAVEDEPS)","no")
+NDEP:=@true
+else
+NDEP:=
+endif
+
 all: $(TARGET)
 
 $(TARGET): $(OBJS)
@@ -89,8 +132,8 @@
 	$(Q)$(CC) -o $@ $(MYLDFLAGS) $^ $(MYLIBS)
 
 bld/%.o: src/%.c bld/.mkdir
-	$(E) DE $@
-	$(Q)$(CC) $(MYCFLAGS) -MM -MT $@ -MF $(patsubst %.o,%.d,$@) $<
+	$(NDEP) $(E) DE $@
+	$(NDEP) $(Q)$(CC) $(MYCFLAGS) -MM -MT $@ -MF $(patsubst %.o,%.d,$@) $<
 	$(E) CC $@
 	$(Q)$(CC) $(MYCFLAGS) -c -o $@ $<
 
@@ -142,6 +185,11 @@
 	@echo NEEDLRT: $(NEEDLRT)
 	@echo HAVESREA: $(HAVESREA)
 	@echo HAVEWDTI: $(HAVEWDTI)
+	@echo HAVEDEPS: $(HAVEDEPS)
+	@echo HAVECSTD: $(HAVECSTD)
+	@echo HAVEFLTA: $(HAVEFLTA)
+	@echo HAVEFLTO: $(HAVEFLTO)
+	@echo HAVELPIE: $(HAVELPIE)
 	@echo MYCFLAGS: $(MYCFLAGS)
 	@echo MYLDFLAGS: $(MYLDFLAGS)
 	@echo MYLIBS: $(MYLIBS)

=== debian/changelog ===
iotop-c (1.27-1) unstable; urgency=medium

  * Update to new upstream release of 1.27
  * Bump standards to 4.7.0, no changes
  * Change pkg-config to pkgconf

 -- Boian Bonev <bbonev@ipacct.com>  Mon, 13 Jan 2025 10:36:15 +0000

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,8 @@
 Build-Depends:
  debhelper-compat (= 13),
  libncurses-dev,
- pkg-config,
-Standards-Version: 4.6.1
+ pkgconf,
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://github.com/Tomas-M/iotop
 Vcs-Browser: https://github.com/Tomas-M/iotop

## iotop-c 1.30

=== debian/changelog ===
iotop-c (1.30-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Boian Bonev <bbonev@ipacct.com>  Sun, 01 Jun 2025 04:12:31 +0000

iotop-c (1.30-1) unstable; urgency=medium

  * Update to new upstream release of 1.30
    - kernel commit 0bf2d83 fixes the problem with struct taskstats
      now iotop 1.30 handles only v15 of the struct in a different
      way, retaining compatibility with both old and new kernels
    - show zero current values for exited processes
    - flush stdout after each batch run

 -- Boian Bonev <bbonev@ipacct.com>  Mon, 26 May 2025 20:24:48 +0000

iotop-c (1.29-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Boian Bonev <bbonev@ipacct.com>  Sat, 17 May 2025 13:40:08 +0000

iotop-c (1.29-1) unstable; urgency=medium

  * Update to new upstream release of 1.29
    - fix backward incompatible change in kernel
      struct taskstats

 -- Boian Bonev <bbonev@ipacct.com>  Tue, 06 May 2025 22:09:06 +0000

iotop-c (1.28-1) unstable; urgency=medium

  * Update to new upstream release of 1.28
    - fix batch mode
  * Bump standards to 4.7.2, no changes

 -- Boian Bonev <bbonev@ipacct.com>  Fri, 02 May 2025 15:07:42 +0000

iotop-c (1.27-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Boian Bonev <bbonev@ipacct.com>  Sat, 18 Jan 2025 23:31:34 +0000

iotop-c (1.26-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Boian Bonev <bbonev@ipacct.com>  Fri, 09 Feb 2024 10:07:03 +0000

iotop-c (1.25-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Boian Bonev <bbonev@ipacct.com>  Sun, 26 Nov 2023 03:22:06 +0000

=== debian/rules ===
#!/usr/bin/make -f

# use the default Debian build options; do not strip as dh_* scripts strip the binary
export NO_FLTO=1
export STRIP=/bin/true
ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
export V=1
else
export V=0
endif
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_install:
	dh_install
	mv debian/iotop-c/usr/sbin/iotop debian/iotop-c/usr/sbin/iotop-c
	mv debian/iotop-c/usr/share/man/man8/iotop.8 debian/iotop-c/usr/share/man/man8/iotop-c.8

## iotop-c 1.31

=== Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 # SPDX-License-Identifier: GPL-2.0-or-later
 #
 # Copyright (C) 2014  Vyacheslav Trushkin
-# Copyright (C) 2020-2025  Boian Bonev
+# Copyright (C) 2020-2026  Boian Bonev
 #
 # This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
 #
@@ -36,6 +36,7 @@
 endif
 
 PREFIX?=$(DESTDIR)/usr
+BINDIR?=$(PREFIX)/sbin
 INSTALL?=install
 STRIP?=strip
 
@@ -57,7 +58,7 @@
 HAVESREA:=$(shell if $(CC) -mno-stackrealign -xc -c /dev/null -o /dev/null >/dev/null 2>/dev/null;then echo yes;else echo no;fi)
 # old comiplers do not have -Wdate-time
 HAVEWDTI:=$(shell if $(CC) -Wdate-time -xc -c /dev/null -o /dev/null >/dev/null 2>/dev/null;then echo yes;else echo no;fi)
-# old compilers can not generate dependecies
+# old compilers can not generate dependencies
 HAVEDEPS:=$(shell if $(CC) -MM -MT /dev/null -MF /dev/null /dev/null >/dev/null 2>/dev/null;then echo yes;else echo no;fi)
 # old compilers do not understand C standard
 HAVECSTD:=$(shell if $(CC) --std=gnu89 -xc -c /dev/null -o /dev/null >/dev/null 2>/dev/null;then echo yes;else echo no;fi)
@@ -145,19 +146,19 @@
 	$(E) STRIP $(TARGET)
 	$(Q)$(STRIP) $(TARGET)
 	$(E) INSTALL $(TARGET)
-	$(Q)$(INSTALL) -D -m 0755 $(TARGET) $(PREFIX)/sbin/$(TARGET)
+	$(Q)$(INSTALL) -D -m 0755 $(TARGET) $(BINDIR)/$(TARGET)
 	$(Q)$(INSTALL) -D -m 0644 iotop.8 $(PREFIX)/share/man/man8/iotop.8
 
 uninstall:
 	$(E) UNINSTALL $(TARGET)
-	$(Q)rm -f $(PREFIX)/sbin/$(TARGET)
+	$(Q)rm -f $(BINDIR)/$(TARGET)
 	$(Q)rm -f $(PREFIX)/share/man/man8/iotop.8
 
 bld/.mkdir:
 	$(Q)mkdir -p bld
 	$(Q)touch bld/.mkdir
 
-VER:=$(shell grep VERSION src/iotop.h|tr -d '\"'|awk '{print $$3}')
+VER:=$(shell grep ' VERSION ' src/iotop.h|tr -d '\"'|awk '{print $$3}')
 mkotar:
 	$(MAKE) clean
 	-dh_clean

=== debian/changelog ===
iotop-c (1.31-1~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Boian Bonev <bbonev@ipacct.com>  Thu, 05 Feb 2026 17:39:56 +0000

iotop-c (1.31-1) unstable; urgency=medium

  [ Renan Rodrigo ]
  * Add autopkgtests

  [ Boian Bonev ]
  * Update to new upstream release of 1.31
  * Bump standards to 4.7.3
  * Remove redundant priority
  * Remove redundant r^3
  * Update year in copyright
  * Change d/watch to version 5

 -- Boian Bonev <bbonev@ipacct.com>  Tue, 20 Jan 2026 13:09:55 +0000

=== debian/tests/control ===
Tests: basic-output iterations real-io
Depends: iotop-c, coreutils
Restrictions: needs-root isolation-machine

=== debian/watch ===
Version: 5
Template: GitHub
Dist: https://github.com/Tomas-M/iotop
DownloadURLMangle: s%(api.github.com/repos/[^/]+/[^/]+)/git/refs/tags/v(@ANY_VERSION@)%github.com/Tomas-M/iotop/releases/download/v$2/iotop-$2.tar.xz%g
PgpSigURLMangle: s/$/.asc/
